//all functions are based off of participantManager (print, config, etc.)

function addSelectOptions(){
   let pM=this;
   let input=pM.inputSelector;
   let config=pM.config;

   let fName='addParticipantSelectOptions';
   pM.print(fName);
   let opt=config.document.createElement("option");
   opt.value=-1;

   opt.text="<Select>";
   input.options[input.options.length]=opt;

   let opt1=config.document.createElement("option");
   opt1.value=0;
   opt1.text="New";
   input.options[input.options.length]=opt1;

   let demoRows=config.formConfig['demographicData'].rows;
   pM.print(fName+" demoRows: "+demoRows.length);
   for (let i=0;i<demoRows.length;i++){
      let opt2=config.document.createElement("option");
      opt2.value=i+1;
      opt2.text=demoRows[i][pM.participantField];
      input.options[input.options.length]=opt2;
      pM.print(fName+' '+pM.participantField+' '+demoRows[i][pM.participantField]);
   }

   input.selectedIndex=0;
}

function updateElements(){
   let pM=this;
   //reset all values (some might be different depending on the call timing)
   pM.cellSelector=config.document.getElementById(pM.cellSelectorId);
   pM.inputSelector=config.document.getElementById(pM.inputSelectorId);
   pM.textSelector=config.document.getElementById(pM.textSelectorId);
   pM.cellValue=config.document.getElementById(pM.cellValueId);
   pM.inputValue=config.document.getElementById(pM.inputValueId);
   pM.textValue=config.document.getElementById(pM.textValueId);
   
   pM.inputManage=config.document.getElementById(pM.inputManageId);
}

function generateEntryField(){
   let pM=this;
   let fName='[generateParticipantEntryField]:';
   pM.print(fName);

   //this is HTML designator of area on page
   let config=pM.config;
	let formName=config.masterForm;

    
   pM.tb=config.document.createElement('table');
   let tb=pM.tb;
	tb.className='t2';
	let row=tb.insertRow();
	
   //header
   let cell=config.document.createElement('th');
	row.appendChild(cell);	
	cell.setAttribute("colspan","1");
	cell.style.fontSize="20px";
	cell.style.textAlign="left";
   //Use study coding for participant field
	cell.innerText=pM.participantField;


   //selector
   let cellSelector=row.insertCell();
   cellSelector.id=pM.cellSelectorId;


   //value
   let cellValue=row.insertCell();
   cellValue.id=pM.cellValueId;

   //manage
   let cellManage=row.insertCell();
   let inputManage=config.document.createElement("input");
   inputManage.type="button";
   //initially in set mode
   inputManage.onclick=function(){pM.manageParticipantId();};
   inputManage.id=pM.inputManageId;
   cellManage.appendChild(inputManage);

   config.document.getElementById(formName).appendChild(tb);

}

//callback
function manageParticipantId(){
   let pM=this;
   let fName='[manageParticipantId]';
   pM.print(fName);
   //this can happen after object was created, so make sure current
   //elements are used
   pM.updateElements();
   if (pM.inputManage.value=="Set"){
      pM.setParticipantId();
      return;
   }
   if (pM.inputManage.value=="Edit"){
      pM.editParticipantId();
      return;
   }
}

//set mode
function setParticipantId(){
   let pM=this;
   let fName='[setParticipantId]';
   pM.print(fName);
   //update to current elements
   pM.print(fName+" select value: "+pM.inputSelector.value+" value: "+pM.inputValue.value);
   if (pM.inputSelector.value<0) return;
   let pId=pM.inputValue.value;
   let opt=pM.inputSelector.options[pM.inputSelector.selectedIndex];
   if (pM.inputSelector.value>0)
      pId=opt.text;

   pM.print(fName+" new value "+pId);
   pM.setParticipantManagerToLabelMode(pId,opt.text);
}

function setParticipantManagerToLabelMode(pId,optText){
   let pM=this;
   let config=pM.config;
   //set crfEntry and upload it to labkey
   let textValue=config.document.createElement("p");
   textValue.innerText=pId;
   textValue.id=pM.textValueId;
   if (pM.inputValue!=undefined)
      pM.cellValue.replaceChild(textValue,pM.inputValue);
   else
      pM.cellValue.appendChild(textValue);

   
   let textSelector=config.document.createElement("p");
   textSelector.innerText=optText;
   textSelector.id=pM.textSelectorId;
   if (pM.inputSelector!=undefined)
      pM.cellSelector.replaceChild(textSelector,pM.inputSelector);
   else
      pM.cellSelector.appendChild(textSelector);

   //addStaticData(participantField,participantField,pid);

   pM.inputManage.value="Edit";
}

function editParticipantId(){
   let pM=this;
   pM.setParticipantManagerToEditMode();
}

function setParticipantManagerToEditMode(){
   let pM=this;
   let config=pM.config;

   let fName='[setParticipantManagerToEditMode]';
   pM.print(fName);
   //input
   let inputValue=config.document.createElement("input");
   inputValue.id=pM.inputValueId;
   pM.print(fName+" value old "+pM.textValue+" new "+inputValue);
   if (pM.textValue!=undefined)
      pM.cellValue.replaceChild(inputValue,pM.textValue);
   else
      pM.cellValue.appendChild(inputValue);

   //select
   let inputSelector = config.document.createElement("select");
   inputSelector.id=pM.inputSelectorId;
   pM.inputSelector=inputSelector;
   pM.addSelectOptions();
   pM.print(fName+" select old "+pM.textSelector+" new "+inputSelector);
   if (pM.textSelector!=undefined)
      pM.cellSelector.replaceChild(inputSelector,pM.textSelector);
   else
      pM.cellSelector.appendChild(inputSelector);

   pM.inputManage.value="Set";

}

function getParticipantField(config){
   return config.formConfig['studyDataAll'].rows[0]['SubjectColumnName'];
}

function getParticipantId(){
   let pM=this;
   //let participantField=config.formConfig['studyDataAll'].rows[0]['SubjectColumnName'];
   return pM.textValue.innerText;
}



//main interface. Use this to generate object and to refer to it later on
function getParticipantManagerObject(config){

   let fName='[getParticipantManagerObject]';

   if ("participantManager" in config) {
      let pM=config.participantManager;
      pM.updateElements();
      return pM;
   }

   let pM=new Object();
   //circular reference to traverse pM up and down
   config.participantManager=pM;
   pM.config=config;
   //config should have a print routine
   pM.print=config.print;

   //this never change
   pM.participantField=getParticipantField(config);


   pM.cellSelectorId=pM.participantField+"_cellSelect";
   pM.inputSelectorId=pM.participantField+"_Select";
   pM.textSelectorId=pM.participantField+"_textSelect";

   pM.cellValueId=pM.participantField+"_cellValue";
   pM.inputValueId=pM.participantField+"_Value";
   pM.textValueId=pM.participantField+"_textValue";

   pM.inputManageId=pM.participantField+"_Manage";
   //add methods
   pM.updateElements=updateElements;
   pM.addSelectOptions=addSelectOptions;
   pM.generateEntryField=generateEntryField;
   pM.manageParticipantId=manageParticipantId;
   pM.setParticipantId=setParticipantId;
   pM.editParticipantId=editParticipantId;
   pM.setParticipantManagerToLabelMode=setParticipantManagerToLabelMode;
   pM.setParticipantManagerToEditMode=setParticipantManagerToEditMode;
   pM.getParticipantId=getParticipantId;

   pM.generateEntryField();
   pM.updateElements();
   return pM;
}
